//
//	CElapsed - determine elapsed time
//
//  1999 Rick York
//
//@tabs=4
//

class CElapsed
  {
  private :
    int		Initialized;
    __int64 Frequency;
    __int64 BeginTime;

  public :
    CElapsed()
			{
			// get the frequency of the counter
			Initialized = QueryPerformanceFrequency(
								(LARGE_INTEGER *)&Frequency );
			}

	BOOL IsValid()     // returns true if the perf. counter is available
			{ return Initialized; }

	__int64 GetFreq()  // return perf. counter frequency as large int
			{ return Frequency; }

    BOOL Begin()	// start timing
			{
			if( ! Initialized ) return 0;		// error
			return QueryPerformanceCounter( (LARGE_INTEGER *)&BeginTime );
			}

    double End()	// stop timing and get elapsed time in seconds
			{
			if( ! Initialized ) return 0.0;		// error

			__int64 endtime;
			QueryPerformanceCounter( (LARGE_INTEGER *)&endtime );
			__int64 elapsed = endtime - BeginTime;
			double dtime = (double)elapsed / (double)Frequency;
			return dtime;
			}
  };

