//
// CProfile.cpp -	the profile handling class
//
//  1999 Rick York
//
//@tabs=4

#include "StdAfx.h"
#include "CProfile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif // _DEBUG


/////////////////////////////////////////////////////////////////////


CProfile::CProfile( ccp inifile )
	{
	IniFile = inifile;
	Topic = NULL;
	}


CProfile::~CProfile()
	{
	}


ccp CProfile::SetTopic( ccp topic )
	{
	ccp oldtopic = Topic;
	Topic = topic;
	return oldtopic;
	}


int	CProfile::GetStr( ccp key, char *defstr, char *retbuf, int bufsize )
	{
	return GetPrivateProfileString( Topic, key, defstr,
								retbuf, bufsize, IniFile );
	}


int	CProfile::PutStr( ccp key, ccp str )
	{
	return WritePrivateProfileString( Topic, key, str, IniFile );
	}


int	CProfile::GetInt( ccp key, int defval )
	{
	return GetPrivateProfileInt( Topic, key, defval, IniFile );
	}


int	CProfile::PutInt( ccp key, int value )
	{
    char buf[32];

    sprintf( buf, "%d", value );
    return PutStr( key, buf );
	}


#define	RL_KEY		"left"
#define	RR_KEY		"right"
#define	RT_KEY		"top"
#define	RB_KEY		"bottom"


int	CProfile::GetRect( RECT *rect )
	{
	rect->left = GetInt( RL_KEY, rect->left );
	rect->top = GetInt( RT_KEY, rect->top );
	rect->right = GetInt( RR_KEY, rect->right );
	rect->bottom = GetInt( RB_KEY, rect->bottom );
	return TRUE;
	}


int	CProfile::PutRect( RECT *rect )
	{
	PutInt( RL_KEY, rect->left );
	PutInt( RT_KEY, rect->top );
	PutInt( RR_KEY, rect->right );
	PutInt( RB_KEY, rect->bottom );
	return TRUE;
	}


#define	PLACEFMT	"%u,%u,%d,%d,%d,%d,%d,%d,%d,%d"
#define	PLACESIZE	(sizeof("65535")*2 + sizeof("-32767")*8)


int CProfile::ReadWinPlace( ccp key, PWINDOWPLACEMENT pwp )
{
	char buffer[PLACESIZE];

	if( ! GetStr( key, "", buffer, sizeof( buffer ) ) )
		return FALSE;

	WINDOWPLACEMENT wp;
	int nRead = sscanf( buffer, PLACEFMT,
						&wp.flags, &wp.showCmd,
						&wp.ptMinPosition.x,
						&wp.ptMinPosition.y,
						&wp.ptMaxPosition.x,
						&wp.ptMaxPosition.y,
						&wp.rcNormalPosition.left,
						&wp.rcNormalPosition.top,
						&wp.rcNormalPosition.right,
						&wp.rcNormalPosition.bottom );

	if( nRead != 10 )
		return FALSE;

	wp.length = sizeof( wp );
	memcpy( pwp, & wp, wp.length );
	return TRUE;
}


void CProfile::WriteWinPlace( ccp key, PWINDOWPLACEMENT pwp )
{
	char buffer[PLACESIZE];

	sprintf( buffer, PLACEFMT,
			pwp->flags, pwp->showCmd,
			pwp->ptMinPosition.x,
			pwp->ptMinPosition.y,
			pwp->ptMaxPosition.x,
			pwp->ptMaxPosition.y,
			pwp->rcNormalPosition.left,
			pwp->rcNormalPosition.top,
			pwp->rcNormalPosition.right,
			pwp->rcNormalPosition.bottom );

	PutStr( key, buffer );
}

