//
// IpcDemo.cpp : Defines the behaviors of the application.
//
//  1999 Rick York
//
//@tabs=4

#include "StdAfx.h"
#include "resource.h"		// main symbols
#include "CProfile.h"

#define MAIN
#include "IpcDemo.h"

#include "RecvDlg.h"
#include "SendDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


///////////////////////////////////////////////////////////////////////
// CIpcDemoApp

BEGIN_MESSAGE_MAP(CIpcDemoApp, CWinApp)
	//{{AFX_MSG_MAP(CIpcDemoApp)
	//}}AFX_MSG
END_MESSAGE_MAP()


// CIpcDemoApp construction

CIpcDemoApp::CIpcDemoApp()
{
	// Place all significant initialization in InitInstance

	m_AppMutex = NULL;
	m_AppLock = NULL;
}


int	CIpcDemoApp::GetAppType( int stringid )
{
	CString mtxname;
	mtxname.LoadString( stringid );
	m_AppMutex = new CMutex( FALSE, mtxname );
	m_AppLock = new CSingleLock( m_AppMutex );
	if( m_AppLock->Lock( 0 ) )
		return TRUE;	// we have the lock

	// lock failed

	delete m_AppLock;
	delete m_AppMutex;
	return 0;
}


// CIpcDemoApp initialization

BOOL CIpcDemoApp::InitInstance()
{
	// Standard initialization

	Enable3dControls();		// using MFC in a shared DLL

	// get profile name

	GetWindowsDirectory( m_IniFile, sizeof( m_IniFile ) );
	strcat( m_IniFile, "\\IpcDemo.ini" );

	// decide which type of app we will be

	int dlgid = GetAppType( IDS_MUTEX_SEND );
	if( dlgid )
		{
		CIpcSendDlg dlg;
		m_pMainWnd = &dlg;
		dlg.DoModal();
		}
	else
		{
		dlgid = GetAppType( IDS_MUTEX_RECV );
		if( ! dlgid )
			{
			::MessageBox( NULL, "Unable to Initialize Application",
						"Error", MB_OK );
			return FALSE;
			}

		CIpcRecvDlg dlg;
		m_pMainWnd = &dlg;
		dlg.DoModal();
		}

	delete m_AppLock;
	delete m_AppMutex;

	return FALSE;
}

