//
// IpcDemo.h : main header file for the IPCDEMO application
//
//  1999 Rick York
//
//@tabs=4
//
#ifdef _IPCDEMO_H
#error repeated include of this file
#else
#define _IPCDEMO_H
#endif


/////////////////////////////////////////////////////////////////////
// message commands

#define	MSGCMD_TEXT		101
#define	MSGCMD_EXIT		102
#define	MSGCMD_TIME		103

// message command structure

#define	MSGCMD_TEXTSIZE	79

#define MSGCMD_MAXLINES	6		// lines of text


typedef struct
	{
	int			command;
	int			line;
	COLORREF	fgcolor;
	COLORREF	bgcolor;
	char		text[MSGCMD_TEXTSIZE+1];
	} MsgCmd;


/////////////////////////////////////////////////////////////////////
// CIpcDemoApp - implementation of this class is in IpcDemo.cpp
//

class CIpcDemoApp : public CWinApp
{
public:
	CIpcDemoApp();

	char	m_IniFile[MAX_PATH];

	CMutex * m_AppMutex;
	CSingleLock *m_AppLock;

	int		GetAppType( int stringid );

// Overrides
	//{{AFX_VIRTUAL(CIpcDemoApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CIpcDemoApp)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////

#ifdef MAIN
#define Global
#else
#define Global extern
#endif


// instance of CIpcDemoApp object

Global CIpcDemoApp theApp;

