//
// RecvDlg.cpp : message receiving dialog implementation
//
//  1999 Rick York
//
//@tabs=4

#include "StdAfx.h"
#include "Resource.h"
#include "IpcDemo.h"
#include "CProfile.h"
#include "RecvDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// profile topics and keys

#define	TOPIC_RECVPOS	"RecvPosition"
#define	KEY_POSX		"xpos"
#define	KEY_POSY		"ypos"


///////////////////////////////////////////////////////////////////////
// CIpcRecvDlg dialog

CIpcRecvDlg::CIpcRecvDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIpcRecvDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIpcRecvDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pLabel[0] = &m_Text1;
	m_pLabel[1] = &m_Text2;
	m_pLabel[2] = &m_Text3;
	m_pLabel[3] = &m_Text4;
	m_pLabel[4] = &m_Text5;
	m_pLabel[5] = &m_Text6;
}

void CIpcRecvDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIpcRecvDlg)
	DDX_Control(pDX, IDC_RCV_LINE1,	m_Text1);
	DDX_Control(pDX, IDC_RCV_LINE2,	m_Text2);
	DDX_Control(pDX, IDC_RCV_LINE3,	m_Text3);
	DDX_Control(pDX, IDC_RCV_LINE4,	m_Text4);
	DDX_Control(pDX, IDC_RCV_LINE5,	m_Text5);
	DDX_Control(pDX, IDC_RCV_LINE6,	m_Text6);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIpcRecvDlg, CDialog)
	//{{AFX_MSG_MAP(CIpcRecvDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_COPYDATA()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CIpcRecvDlg message handlers

BOOL CIpcRecvDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.
	// The framework does this automatically when
	// when the app's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// extra initialization

	CProfile prf( theApp.m_IniFile );
	prf.SetTopic( TOPIC_RECVPOS );
	int wx = prf.GetInt( KEY_POSX, 200 );
	int wy = prf.GetInt( KEY_POSY, 440 );

	SetWindowPos( NULL, wx, wy, 0, 0, SWP_NOSIZE | SWP_NOZORDER );

	// set the title text

	CString title;
	title.LoadString( IDS_NAME_RECV );
	SetWindowText( title );

	// clear the lines

	int x;
	for( x = 0; x < MSGCMD_MAXLINES; x += 1 )
		m_pLabel[x]->SetWindowText( "" );
	return TRUE;
}


// If you add a minimize button to your dialog,
// you will need the code below to draw the icon.  

void CIpcRecvDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display
// while the user drags the minimized window.
HCURSOR CIpcRecvDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CIpcRecvDlg::OnClose() 
{
	// trap alt+f4
	TRACE( "CIpcRecvDlg::OnClose\n" );
//	CDialog::OnClose();
}


BOOL CIpcRecvDlg::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pData) 
{
	// if size doesn't match we don't know what this is

	if( pData->cbData == sizeof( MsgCmd ) )
		{
		MsgCmd msg;
		memcpy( &msg, pData->lpData, sizeof( MsgCmd ) );

		// process message

		switch( msg.command )
			{
			case MSGCMD_TIME :
				break;

			case MSGCMD_EXIT :
				{
				// save window position

				CProfile prf( theApp.m_IniFile );
				prf.SetTopic( TOPIC_RECVPOS );
				RECT rect;
				GetWindowRect( &rect );
				int wx = max( rect.left, 0 );
				int wy = max( rect.top, 0 );

				prf.PutInt( KEY_POSX, wx );
				prf.PutInt( KEY_POSY, wy );

				EndDialog( IDOK );
				break;
				}
			case MSGCMD_TEXT :
				{
				int linendx = msg.line;
				if( ( linendx < 1 ) || ( linendx > MSGCMD_MAXLINES ) )
					{
					MessageBox( "Received Line Index Out of Range",
								"Error" );
					break;
					}
				linendx -= 1;
				CLabel *pl = m_pLabel[linendx];
				pl->SetTextColor( msg.fgcolor );
				pl->SetBkColor( msg.bgcolor );
				pl->SetText( msg.text );
				break;
				}
			default :
				{
				char buffer[64];
				sprintf( buffer, "Received Message Command %d",
						msg.command );
				MessageBox( buffer, "Error" );
				}
			}

		return TRUE;
		}

	return CDialog::OnCopyData(pWnd, pData);
}

